using System;
using System.Data;
using System.Data.SqlClient;
using System.Configuration;
using System.Net.Mail;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Text;
using System.Drawing;
using System.Drawing.Imaging;
using System.Drawing.Drawing2D;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.IO.Compression;
using System.Linq;

/// <summary>
/// Summary description for dbclass
/// </summary>

public class dbclass
{
    //public string seorewrite = ConfigurationManager.AppSettings["seorewrite"].ToString();
    public string connstring = ConfigurationManager.AppSettings["connstr"].ToString();

    public DataSet GetData(string qry) // for select Query   returns dataset 
    {
        SqlConnection con = new SqlConnection(connstring);
        SqlDataAdapter da = new SqlDataAdapter(qry, con);
        DataSet ds = new DataSet();
        try
        {
            if (con.State == ConnectionState.Closed) { con.Open(); }
            da.Fill(ds);
        }
        catch (Exception ex) { }
        finally
        {
            con.Close();
            SqlConnection.ClearPool(con);
        }
        da.Dispose(); 
        return ds;
    }

    public int ChangeData(string qry) // for add update delete
    {
        // executes query and returns 0 or 1 for failure or sucess  
        SqlConnection con = new SqlConnection(connstring);
        SqlCommand cmd = new SqlCommand(qry, con);
        int i = 0;
        try
        {
            if (con.State == ConnectionState.Closed) { con.Open(); }
            cmd.CommandTimeout = 0;
            i = cmd.ExecuteNonQuery();

        }
        catch (Exception ex) { }
        finally
        {
            con.Close();
            SqlConnection.ClearPool(con);
            cmd.Dispose();
        }
        if (i > 0)
        {
            return i;
        }
        else
        {
            return 0;
        }
    }

    public bool Chkdbvalue(string strtable, string strnamefield, string cond)
    {
        //For checking if the value exist or not in the database
        SqlConnection con = new SqlConnection(connstring);
        bool functionReturnValue = false;
        SqlDataReader dbread = null; //default(SqlDataReader);
        string qry = "select " + strnamefield + " from " + strtable;
        if (!string.IsNullOrEmpty(cond)) qry = qry + " where " + cond + "";
        SqlCommand cmd = new SqlCommand(qry, con);
        dbread = cmd.ExecuteReader();
        if (dbread.HasRows == true)
        {
            while (dbread.Read())
            {
                functionReturnValue = true;
            }
        }
        dbread.Close();
        cmd.Dispose();
        con.Close();
        SqlConnection.ClearPool(con);
        return functionReturnValue;
    }
    
    public bool Chkdouble(string strtable, string strnamefield, string cond)
    {
        bool functionReturnValue = false;
        //For checking if the value exist or not
        SqlDataReader dbread = null; // default(SqlDataReader);
        functionReturnValue = false;
        string sqlchkdouname = "select " + strnamefield + " from " + strtable + " where " + cond + "";
        string qry = null;
        qry = "select " + strnamefield + " from " + strtable;
        if (!string.IsNullOrEmpty(cond)) qry = qry + " where " + cond + "";
        SqlConnection con = new SqlConnection(connstring);
        if (con.State == ConnectionState.Closed) con.Open();
        SqlCommand cmd = new SqlCommand(qry, con);
        dbread = cmd.ExecuteReader();
        if (dbread.HasRows == true)
        {
            while (dbread.Read())
            {
                functionReturnValue = true;
            }
        }
        dbread.Close();
        cmd.Dispose();
        con.Close();
        SqlConnection.ClearPool(con);
        return functionReturnValue;
    }

    public bool ExecuteNonQuery(string strquery, SqlParameter[] SqlParam)
    {
        SqlConnection con = new SqlConnection(connstring);
        SqlCommand cmd = new SqlCommand(strquery, con);
        Boolean xflag = false;
        try
        {
            if (con.State == ConnectionState.Closed) { con.Open(); }
            cmd.CommandType = CommandType.StoredProcedure;
            if (cmd.CommandType == System.Data.CommandType.StoredProcedure)
            {
                if (SqlParam != null)
                {
                    foreach (SqlParameter param in SqlParam)
                    {
                        cmd.Parameters.Add(param);
                    }
                }
            }
            cmd.ExecuteNonQuery();
            xflag = true;
        }
        catch (Exception ex) { xflag = false; }
        finally
        {
            con.Close();
            cmd.Dispose();
            SqlConnection.ClearPool(con);
        }
        return xflag;
    }
    
    public Boolean dmlDataProc(string strquery, SqlParameter[] SqlParam)
    {
        //For DML commands  (Insert,Update,Delete)
        SqlConnection con = new SqlConnection(connstring);
        SqlCommand cmd = new SqlCommand(strquery, con);
        Boolean xflag = false;
        try
        {
            if (con.State == ConnectionState.Closed) { con.Open(); }
            cmd.CommandType = CommandType.StoredProcedure;
            if (cmd.CommandType == System.Data.CommandType.StoredProcedure)
            {
                if (SqlParam != null)
                {
                    foreach (SqlParameter param in SqlParam)
                    {
                        cmd.Parameters.Add(param);
                    }
                }
            }
            cmd.ExecuteNonQuery();
            xflag = true;
        }
        catch (Exception ex) { xflag = false; }
        finally
        {
            con.Close();
            cmd.Dispose();
            SqlConnection.ClearPool(con);
        }
        return xflag;
    }

    public DataSet ddlDataProc(string strqry, SqlParameter[] ParamName)
    {
        //For Retriving  the Records in the dataset
        SqlConnection con = new SqlConnection(connstring);
        SqlCommand cmd = new SqlCommand(strqry, con);
        SqlDataAdapter da = new SqlDataAdapter(cmd);
        DataSet dsgetData = new DataSet();
        try
        {
            if (con.State == ConnectionState.Closed)
            {
                con.Open();
                cmd.CommandText = strqry;
                cmd.CommandType = CommandType.StoredProcedure;

                if (cmd.CommandType == System.Data.CommandType.StoredProcedure)
                {
                    foreach (SqlParameter param in ParamName)
                    {
                        if (param.Value != null)
                        {
                            cmd.Parameters.Add(param);
                        }
                    }
                }
                da.SelectCommand = cmd;
                da.Fill(dsgetData);
            }
        }
        catch (Exception ex) { }
        finally
        {
            cmd.Parameters.Clear();
            con.Close();
            cmd.Dispose();
            da.Dispose();
            SqlConnection.ClearPool(con);
        }
        return dsgetData;
    }
    
    public void fnPage(ref DataList Dlst, string strQry, int PageSize, string strPageName, string strPageQuery, ref Label lblpaging, int intPgdisp, string QryPgno, string QryPgnoNm, string QryPg, string QryPgnm)
    {
        DataSet ds = default(DataSet);
        Double recordcount = 0.00;
        Int32 pg = default(Int32);
        Int32 pgno = default(Int32);
        Int32 index = default(Int32);
        Double pagecount = 0.00;
        string pgname = null;
        string txtpg = null;
        ds = GetData(strQry);
        if (ds.Tables[0].Rows.Count > 0)
        {
            recordcount = ds.Tables[0].Rows.Count;
            if ((!string.IsNullOrEmpty(QryPgno)))
            {
                pgno = IsInteger(QryPgno);
                if ((pgno == 0)) pgno = 1;
            }
            else
            {
                pgno = 1;
            }
            // page starting block 
            if ((!string.IsNullOrEmpty(QryPg)))
            {
                pg = IsInteger(QryPg);
                if ((pg == 0)) pg = 1;
            }
            else
            {
                pg = 1;
            }
            if ((pgno == 1))
            {
                index = 0;
            }
            else
            {
                index = (pgno - 1) * PageSize;
            }
            if (index < 0) index = 0;

            pagecount = Math.Round((recordcount) / PageSize, 2);

            pagecount = pagecount + 0.49;
            pagecount = Math.Round(pagecount, 0);

            // start to round up page fractions 
            //string i = null;
            //int p = 0;
            //i = Convert.ToString(Math.Round(((recordcount - 1) / PageSize)));
            //p = Convert.ToInt16(i.Substring(i.IndexOf(".") + 1, 1));
            //HttpContext.Current.Response.Write(PageSize);
            //if (p < 4)
            //{
            //    if (recordcount > PageSize & recordcount < (PageSize * (pagecount + 1)))
            //    {
            //        pagecount = (Int32)Math.Round((recordcount - 1) / PageSize + 1);
            //    }
            //}
            // end to round up page fractions 

            ds = ret_dspage_all(strQry, index, PageSize, "temp");
            Dlst.DataSource = ds.Tables[0];
            Dlst.DataBind();
            ds.Clear();

            //' Code for Paging 
            if ((pagecount > 1))
            {
                pgname = strPageName + "?";
                if (!string.IsNullOrEmpty(strPageQuery.Trim())) pgname = pgname + strPageQuery + "&";
                txtpg = "<table cellpadding=0 cellspacing=0 border=0 align='right' >";
                txtpg = txtpg + "<tr align='right' class='paging'>";
                txtpg = txtpg + "<td width='' align='center' nowrap></td>";
                txtpg = txtpg + "<td align='center' nowrap > ";
                if (pgno > 1)
                {
                    if ((pgno % intPgdisp) == 1)
                    {
                        txtpg = txtpg + "<a href='" + pgname + QryPgnoNm + "=" + (pgno - 1) + "&" + QryPgnm + "=" + Convert.ToString(pg - intPgdisp) + "'>Previous</a> ";
                    }
                    else
                    {
                        txtpg = txtpg + "<a href='" + pgname + QryPgnoNm + "=" + (pgno - 1) + "&" + QryPgnm + "=" + pg + "'>Previous</a> ";
                    }
                }
                txtpg = txtpg + "&nbsp;";
                if (pg > 1)
                {
                    txtpg = txtpg + "<a href='" + pgname + QryPgnoNm + "=" + (pg - intPgdisp) + "&" + QryPgnm + "=" + (pg - intPgdisp) + "'>&lt;&lt;&lt;" + (pg - 1) + "</a>&nbsp;";
                }
                int j = 0;
                for (j = pg; j <= pagecount; j = j + 1)
                {
                    if (j == pgno)
                    {
                        txtpg = txtpg + j + "&nbsp;";
                    }
                    else
                    {
                        txtpg = txtpg + "<a href='" + pgname + QryPgnoNm + "=" + j + "&" + QryPgnm + "=" + pg + "'>" + j + " </a>&nbsp;";
                    }
                    if ((j % intPgdisp) == 0)
                    {
                        if (j < pagecount)
                        {
                            txtpg = txtpg + "&nbsp;<a href='" + pgname + QryPgnoNm + "=" + (j + 1) + "&" + QryPgnm + "=" + (j + 1) + "'>" + (j + 1) + "&gt;&gt;&gt; </a>&nbsp; ";
                        }
                        break; // TODO: might not be correct. Was : Exit For 
                    }
                }
                txtpg = txtpg + "</td>";
                txtpg = txtpg + "<td align=right nowrap> ";
                if (pgno < pagecount)
                {
                    if ((pgno % intPgdisp) == 0)
                    {
                        txtpg = txtpg + "<a href='" + pgname + QryPgnoNm + "=" + (pgno + 1) + "&" + QryPgnm + "=" + (pg + intPgdisp) + "'>Next</a>";
                    }
                    else
                    {
                        txtpg = txtpg + "<a href='" + pgname + QryPgnoNm + "=" + (pgno + 1) + "&" + QryPgnm + "=" + pg + "'>Next</a>";
                    }
                }
                txtpg = txtpg + "</td> ";
                txtpg = txtpg + "</tr>";
                txtpg = txtpg + "</table>";
                lblpaging.Visible = true;
                lblpaging.Text = txtpg;

            }
            else
            {
                lblpaging.Visible = false;
            }
            Dlst.Visible = true;
        }
        else
        {
            Dlst.Visible = false;
        }
        ds.Dispose();
    }
    
    public DataSet ret_dspage_all(string strqry, int index, int pagesize, string tbl)
    {
        // for paging 
        //strqry = Replace(UCase(strqry), "'", "`") 
        strqry = strqry.Replace(";", "");
        strqry = strqry.Replace("NGG.JS", "eall.js");
        strqry = strqry.Replace("DECLARE", "xdelcare");
        strqry = strqry.Replace(".JS", "fun.js");
        strqry = strqry.Replace("CAST", "");
        strqry = strqry.Replace("EXEC", "xxexec");
        SqlConnection con = new SqlConnection(connstring);
        if (con.State == ConnectionState.Closed) { con.Open(); }

        SqlCommand cmd = new SqlCommand(strqry, con);
        SqlDataAdapter da = new SqlDataAdapter(cmd);
        DataSet dsSQL = new DataSet();
        cmd.CommandText = strqry;
        da.Fill(dsSQL, index, pagesize, tbl);

        da.Dispose();
        cmd.Dispose();
        con.Close();
        con.Dispose();
        SqlConnection.ClearPool(con);
        return dsSQL;
    }

    public void BindDropdown(string strid, string strname, string strtable, DropDownList strdd, string cond)
    {
        // binding dropdowns 
        string sql="";
        if (cond == "")
        {
            sql = "select " + strid + "," + strname + " from " + strtable; //+ " order by " + strname;
        }
        else
        {
            sql = "select " + strid + "," + strname + " from " + strtable; //+ " where " + cond + " order by " + strname;
        }
        SqlConnection con = new SqlConnection(connstring);
        if (con.State == ConnectionState.Closed) { con.Open(); }
        SqlCommand dbcomm = new SqlCommand(sql, con);
        SqlDataReader dbread;
        dbread = dbcomm.ExecuteReader();
        strdd.DataSource = dbread;
        strdd.DataTextField = strname;
        strdd.DataValueField = strid;
        strdd.DataBind();
        dbread.Close();
        dbcomm.Dispose();
        con.Close();
        con.Dispose();
        SqlConnection.ClearPool(con);
    }

    public void ResizeAndSaveImage(string phypath, string imgpath, int xwidth, int xheight, string xdefimage, System.Web.UI.WebControls.Image imgresize)
    {
        // for dynamically resizing an image
        int xmaxwidth = 0;
        int xmaxheight = 0;
        System.Drawing.Image fullSizeImg = default(System.Drawing.Image);
        phypath = phypath.Trim();
        imgpath = imgpath.Trim();

        float xa = 0;
        float xb = 0;
        float w = 0;
        float h = 0;
        if (System.IO.File.Exists(phypath))
        {
            xmaxwidth = Convert.ToInt32(xwidth);
            xmaxheight = Convert.ToInt32(xheight);
            try
            {
                fullSizeImg = System.Drawing.Image.FromFile(phypath);
                h = Convert.ToInt32(fullSizeImg.Height);
                w = Convert.ToInt32(fullSizeImg.Width);
                fullSizeImg.Dispose();
                xa = w / xmaxwidth;
                // width
                xb = h / xmaxheight;
                // height

                if (xb > 1)
                {
                    // height
                    h = xmaxheight;
                    // set to maxheight
                    w = w / xb;
                    xa = w / xmaxwidth;
                    xb = h / xmaxheight;
                }
                if (xa > 1)
                {
                    // width
                    w = xmaxwidth;
                    // set to maxwidth
                    h = h / xa;
                    xa = w / xmaxwidth;
                    xb = h / xmaxheight;
                }
                h = Convert.ToInt32(h);
                w = Convert.ToInt32(w);
            }
            catch (Exception ex)
            {
                h = xmaxheight;
                w = xmaxwidth;
            }
            imgresize.Width = Convert.ToInt32(w);
            imgresize.Height = Convert.ToInt32(h);
            imgresize.ImageUrl = imgpath;
        }
        else
        {
            if (!string.IsNullOrEmpty(xdefimage))
            {
                imgresize.Width = xwidth;
                imgresize.Height = xheight;
                imgresize.ImageUrl = xdefimage;
            }
            else
            {
                imgresize.Visible = false;
            }
        }
    }
    
    public string FnRepQuotes(string txtname)
    {
        txtname = (txtname.Trim() + " ");
        txtname = txtname.Replace("'", "''").TrimEnd();
        return txtname;
    }
    
    public int IsInteger(string sText)
    {
        int num = 0;
        try
        {
            num = Convert.ToInt32(sText, 10);
            return num;
        }
        catch
        {
            return 0;
        }
    }
    
    public bool checkFileType(string fileName)
    {
        string fileExt = Path.GetExtension(fileName);
        switch (fileExt.ToLower())
        {
            case ".gif":
                return true;
            case ".png":
                return true;
            case ".jpg":
                return true;
            case ".jpeg":
                return true;
            default:
                return false;
        }
    }

    public string BindPageAuthentication(int TempId, string TempPageUrl)
    {
        string strValue = "";
        DataSet dsStr = new DataSet();

        string str = "SELECT tbl_Admin.*, tbl_AdminPageAuthentication.*, tbl_Pages.* FROM tbl_Admin INNER JOIN tbl_AdminPageAuthentication ON tbl_Admin.A_Id = tbl_AdminPageAuthentication.A_Id INNER JOIN tbl_Pages ON tbl_AdminPageAuthentication.Page_Id = tbl_Pages.Page_Id WHERE tbl_Admin.A_Id = " + TempId + " And tbl_Pages.Page_Url = '" + TempPageUrl + "'";
        dsStr = GetData(str);

        if (dsStr.Tables[0].Rows.Count > 0)
        {
            strValue = dsStr.Tables[0].Rows[0]["Page_View"].ToString() + "#" + dsStr.Tables[0].Rows[0]["Page_Add"].ToString() + "#" + dsStr.Tables[0].Rows[0]["Page_Edit"].ToString() + "#" + dsStr.Tables[0].Rows[0]["Page_Delete"].ToString();
        }
        dsStr.Clear();

        return strValue;
    }
}

