﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data.SqlClient;
using System.Data;

public partial class Supplier_PersonList : System.Web.UI.Page
{
    dbclass obj = new dbclass();
    DataSet ds = new DataSet();

    protected void Page_Load(object sender, EventArgs e)
    {
        if (Convert.ToString(Session["aid"]) + "" != "")
        {
            if (!IsPostBack)
            {
                string TempValue = obj.BindPageAuthentication(Convert.ToInt32(Session["aid"]), Convert.ToString("Supplier.aspx"));
                if (TempValue != "")
                {
                    string[] ParamTempValue = TempValue.Split('#');
                    ViewState["Page_View"] = ParamTempValue[0].ToString();
                    ViewState["Page_Add"] = ParamTempValue[1].ToString();
                    ViewState["Page_Edit"] = ParamTempValue[2].ToString();
                    ViewState["Page_Delete"] = ParamTempValue[3].ToString();

                    if (Request.QueryString["Id"] + "" != "")
                    {
                        BindDetail();
                        ViewState["sortOrder"] = "";
                        bindgrid("", "");
                    }

                    if (ViewState["Page_Add"].ToString() == "True")
                    {
                        btnAdd.Visible = true;
                    }
                    else
                    {
                        btnAdd.Visible = false;
                    }
                }
                else
                {
                    Response.Redirect("Welcome.aspx?Return=Y");
                }
            }
        }
        else
        {
            //Response.Redirect("Index.aspx");
            Session["aid"] = "1";
            Response.Redirect("Welcome.aspx", false);
        }
    }

    public void BindDetail()
    {
        SqlParameter[] ParamList = new SqlParameter[2];

        ParamList[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList[0].Value = 4;

        ParamList[1] = new SqlParameter("@Supplier_Id", SqlDbType.Int);
        ParamList[1].Value = Convert.ToInt32(Request.QueryString["Id"]);

        ds = obj.ddlDataProc("sp_tbl_Supplier", ParamList);

        if (ds.Tables[0].Rows.Count > 0)
        {
            lblSupplierName.Text = ds.Tables[0].Rows[0]["Supplier_Name"].ToString();
        }
        ds.Clear();
        ParamList = null;
    }

    public void bindgrid(string colname, string ord)
    {
        SqlParameter[] ParamList1 = new SqlParameter[4];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = 0;

        if (colname != "")
        {
            ParamList1[1] = new SqlParameter("@colname", colname);
        }
        else
        {
            ParamList1[1] = new SqlParameter("@colname", null);
        }
        if (ord != "")
        {
            ParamList1[2] = new SqlParameter("@ord", ord);
        }
        else
        {
            ParamList1[2] = new SqlParameter("@ord", null);
        }

        ParamList1[3] = new SqlParameter("@Supplier_Id", SqlDbType.Int);
        ParamList1[3].Value = Convert.ToInt32(Request.QueryString["Id"]);

        ds = obj.ddlDataProc("sp_tbl_SupplierPerson", ParamList1);

        if (ds.Tables[0].Rows.Count > 0)
        {
            lblmsg.Visible = false;
            tr_Form.Visible = false;
            tr_Grid.Visible = true;
        }
        else
        {
            tr_Form.Visible = false;
            tr_Grid.Visible = true;
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "There is no person details to display";
        }
        gv_SupplierPersonList.DataSource = ds;
        gv_SupplierPersonList.DataBind();

        ds.Clear();
        ParamList1 = null;
    }

    protected void gv_SupplierPersonList_RowDataBound(object sender, GridViewRowEventArgs e)
    {
        if (ViewState["Page_Edit"].ToString() == "True")
        {
            e.Row.Cells[1].Visible = true;
        }
        else
        {
            e.Row.Cells[1].Visible = false;
        }

        if (ViewState["Page_Delete"].ToString() == "True")
        {
            e.Row.Cells[8].Visible = true;
        }
        else
        {
            e.Row.Cells[8].Visible = false;
        }

        if (e.Row.RowType == DataControlRowType.DataRow)
        {
            if (((Label)e.Row.FindControl("lblDisplay1")).Text.ToString() == "True")
            {
                ((Label)e.Row.FindControl("lblDisplay")).Text = "Yes";
            }
            else if (((Label)e.Row.FindControl("lblDisplay1")).Text.ToString() == "False")
            {
                ((Label)e.Row.FindControl("lblDisplay")).Text = "No";
            }
        }
    }

    public void ClearFields()
    {
        txtName.Text = "";
        txtDepartment.Text = "";
        txtEmailId.Text = "";
        txtPhone.Text = "";
        txtMobile.Text = "";
        rblDisplay.ClearSelection();
        rblDisplay.Items[0].Selected = true;
        txtEnteredBy.Text = "";
    }

    protected void btnAdd_Click(object sender, EventArgs e)
    {
        tr_Grid.Visible = false;
        tr_Form.Visible = true;
        ClearFields();
        btnSave.Visible = true;
        btnUpdate.Visible = false;
        lblmsg.Visible = false;
    }

    protected void btnSave_Click(object sender, EventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[9];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "1";

        ParamList1[1] = new SqlParameter("@Supplier_Id", SqlDbType.Int);
        ParamList1[1].Value = Convert.ToUInt32(Request.QueryString["Id"]);

        ParamList1[2] = new SqlParameter("@SupPerson_Name", SqlDbType.VarChar);
        ParamList1[2].Value = Convert.ToString(txtName.Text);

        ParamList1[3] = new SqlParameter("@SupPerson_Department", SqlDbType.VarChar);
        ParamList1[3].Value = Convert.ToString(txtDepartment.Text);

        ParamList1[4] = new SqlParameter("@SupPerson_EmailId", SqlDbType.VarChar);
        ParamList1[4].Value = Convert.ToString(txtEmailId.Text);

        ParamList1[5] = new SqlParameter("@SupPerson_Active", SqlDbType.Bit);
        ParamList1[5].Value = Convert.ToBoolean(rblDisplay.SelectedValue);

        ParamList1[6] = new SqlParameter("@SupPerson_Contact_Phone", SqlDbType.VarChar);
        ParamList1[6].Value = Convert.ToString(txtPhone.Text);

        ParamList1[7] = new SqlParameter("@SupPerson_Contact_Mobile", SqlDbType.VarChar);
        ParamList1[7].Value = Convert.ToString(txtMobile.Text);

        ParamList1[8] = new SqlParameter("@Details_Entered_By", SqlDbType.VarChar);
        ParamList1[8].Value = Convert.ToString(txtEnteredBy.Text);

        if (obj.dmlDataProc("sp_tbl_SupplierPerson", ParamList1))
        {
            bindgrid("", "");
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Data inserted succesfully.";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Please Enter Valid Data";
        }
        ClearFields();
        ParamList1 = null;
    }

    protected void btnBack_Click(object sender, EventArgs e)
    {
        ClearFields();
        gv_SupplierPersonList.EditIndex = -1;
        bindgrid("", "");
    }

    protected void gv_SupplierPersonList_RowEditing(object sender, GridViewEditEventArgs e)
    {
        tr_Grid.Visible = false;
        tr_Form.Visible = true;
        ClearFields();
        btnSave.Visible = false;
        btnUpdate.Visible = true;
        lblmsg.Visible = false;
        SqlParameter[] ParamList = new SqlParameter[2];

        ParamList[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList[0].Value = 4;

        ParamList[1] = new SqlParameter("@SupPerson_Id", SqlDbType.Int);
        ParamList[1].Value = gv_SupplierPersonList.DataKeys[e.NewEditIndex].Value;

        ViewState["gridid"] = gv_SupplierPersonList.DataKeys[e.NewEditIndex].Value;

        ds = obj.ddlDataProc("sp_tbl_SupplierPerson", ParamList);

        if (ds.Tables[0].Rows.Count > 0)
        {
            txtName.Text = ds.Tables[0].Rows[0]["SupPerson_Name"].ToString();
            txtDepartment.Text = ds.Tables[0].Rows[0]["SupPerson_Department"].ToString();
            txtEmailId.Text = ds.Tables[0].Rows[0]["SupPerson_EmailId"].ToString();
            txtPhone.Text = ds.Tables[0].Rows[0]["SupPerson_Contact_Phone"].ToString();
            txtMobile.Text = ds.Tables[0].Rows[0]["SupPerson_Contact_Mobile"].ToString();
            rblDisplay.SelectedValue = ds.Tables[0].Rows[0]["SupPerson_Active"].ToString();
            txtEnteredBy.Text = ds.Tables[0].Rows[0]["Details_Entered_By"].ToString();
        }
        ds.Clear();
        ParamList = null;
    }

    protected void btnUpdate_Click(object sender, EventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[10];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "2";

        ParamList1[1] = new SqlParameter("@Supplier_Id", SqlDbType.Int);
        ParamList1[1].Value = Convert.ToUInt32(Request.QueryString["Id"]);

        ParamList1[2] = new SqlParameter("@SupPerson_Name", SqlDbType.VarChar);
        ParamList1[2].Value = Convert.ToString(txtName.Text);

        ParamList1[3] = new SqlParameter("@SupPerson_Department", SqlDbType.VarChar);
        ParamList1[3].Value = Convert.ToString(txtDepartment.Text);

        ParamList1[4] = new SqlParameter("@SupPerson_EmailId", SqlDbType.VarChar);
        ParamList1[4].Value = Convert.ToString(txtEmailId.Text);

        ParamList1[5] = new SqlParameter("@SupPerson_Active", SqlDbType.Bit);
        ParamList1[5].Value = Convert.ToBoolean(rblDisplay.SelectedValue);

        ParamList1[6] = new SqlParameter("@SupPerson_Contact_Phone", SqlDbType.VarChar);
        ParamList1[6].Value = Convert.ToString(txtPhone.Text);

        ParamList1[7] = new SqlParameter("@SupPerson_Contact_Mobile", SqlDbType.VarChar);
        ParamList1[7].Value = Convert.ToString(txtMobile.Text);

        ParamList1[8] = new SqlParameter("@Details_Entered_By", SqlDbType.VarChar);
        ParamList1[8].Value = Convert.ToString(txtEnteredBy.Text);

        ParamList1[9] = new SqlParameter("@SupPerson_Id", SqlDbType.Int);
        ParamList1[9].Value = Convert.ToInt32(ViewState["gridid"]);

        if (obj.dmlDataProc("sp_tbl_SupplierPerson", ParamList1))
        {
            bindgrid("", "");
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Data updated succesfully.";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Please Enter Valid Data";
        }
        ClearFields();
        ParamList1 = null;
    }

    protected void gv_SupplierPersonList_RowDeleting(object sender, GridViewDeleteEventArgs e)
    {
        SqlParameter[] ParamList1 = new SqlParameter[2];

        ParamList1[0] = new SqlParameter("@Sp_Type", SqlDbType.Int);
        ParamList1[0].Value = "3";

        ParamList1[1] = new SqlParameter("@SupPerson_Id", SqlDbType.Int);
        ParamList1[1].Value = gv_SupplierPersonList.DataKeys[e.RowIndex].Value;

        bool bldelart;
        bldelart = obj.dmlDataProc("sp_tbl_SupplierPerson", ParamList1);

        bindgrid("", "");
        if (bldelart == true)
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "successmsg";
            lblmsg.Text = "Record Deleted Successfully";
        }
        else
        {
            lblmsg.Visible = true;
            lblmsg.CssClass = "errormsg";
            lblmsg.Text = "Records not Deleted sucessfully";
        }
        ParamList1 = null;
    }

    protected void btnBackToSpplier_Click(object sender, EventArgs e)
    {
        Response.Redirect("Supplier.aspx");
    }
}